local L = LibStub("AceLocale-3.0"):GetLocale("ProximoGrid", true)
StatusNotTargetable = ProximoGridStatus.NewModule("StatusNotTargetable", {
	useClassColors = true,
	color = {1, 1, 1, 0.3},
	priority = 90
});
StatusNotTargetable.header = L["Not Targetable"];
StatusNotTargetable.options = {
	color = {

		type = "color",
		name = L["Color"],
		desc = L["Color."],
		hasAlpha = true,
		get = function()
			local tmpColor = StatusNotTargetable.db.color;
			return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
		end,
		set = function(r, g, b, a)
			local tmpColor = StatusNotTargetable.db.color;
			tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
		end,

	},
	alpha = {
		type = "range",
		name = L["Alpha"],
		desc = L["Alpha."],
		get = function()
			return StatusNotTargetable.db.color[4];
		end,
		set = function(v)
			StatusNotTargetable.db.color[4] = v;
		end,
		min = 0,
		max = 1,
		step = 0.01
	},
	priority = {
		type = "range",
		name = L["Priority"],
		desc = L["Priority."],
		get = function()
			return StatusNotTargetable.db.priority;
		end,
		set = function(v)
			StatusNotTargetable.db.priority = v;
		end,
		min = 1,
		max = 99,
		step = 1
	}
}


function StatusNotTargetable:PROXIMOGRID_UNIT_ADDED(unitID, unitLink, unitName, unitClass, unitRace, unitSex)
	if (InCombatLockdown() and not ProximoGrid:inArenaZone()) then
		local r, g, b, a;
		local tmpColor = StatusNotTargetable.db.color;
		r, g, b, a = tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4];
		StatusNotTargetable:SendStatusGained(unitID, unitName, "statusNotTargetable", StatusNotTargetable.db.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, L["Not Targetable"],  0, 0, nil, 0, 0, 0);
	end
end

function StatusNotTargetable:PLAYER_REGEN_ENABLED()
	if (not ProximoGrid:inArenaZone()) then
		for k, v in pairs(ProximoGrid.UnitFrames) do
			StatusNotTargetable:SendStatusLost(v.unitID, "statusNotTargetable");
		end
	end
end

function StatusNotTargetable:OnInitialize()
	StatusNotTargetable:RegisterStatus("statusNotTargetable", L["Not Targetable"]);
end

function StatusNotTargetable:OnEnable()
	StatusNotTargetable:RegisterEvent("PLAYER_REGEN_ENABLED");
	StatusNotTargetable:RegisterEvent("PROXIMOGRID_UNIT_ADDED");

end

function StatusNotTargetable:OnDisable()
	StatusNotTargetable:UnregisterEvent("PLAYER_REGEN_ENABLED");
	StatusNotTargetable:UnregisterEvent("PROXIMOGRID_UNIT_ADDED");
end